from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("servosandstack", "ServoStackMount", inherit=("lServoMount.depth", "lServoMount.width", "stack.length"), prefix=None)
c.inheritAllInterfaces("servosandstack")

c.addSubcomponent("batterymount", "BatteryMount")
c.inheritAllInterfaces("batterymount")

c.addSubcomponent("lfullsplit", "SplitEdge", inherit=True)
c.inheritAllInterfaces("lfullsplit")
c.addConstraint(("lfullsplit", "toplength"), ("lServoMount.depth", "lServoMount.width", "stack.length"), "(x[0]*2+x[1]*2+10*2+x[2],)")
c.addConstraint(("lfullsplit", "botlength"), ("lServoMount.depth", "lServoMount.width", "stack.length"), "(x[0]*2+x[1]*2+10*2, x[2])")

c.addConnection(("lfullsplit", "topedge0"), ("servosandstack", "lservostacksplit"))
c.addConnection(("batterymount", "rightArmInterface"), ("lfullsplit", "botedge1"), tabWidth=10) #first interface gets the tab, second interface gets the slot

c.addSubcomponent("rfullsplit", "SplitEdge", inherit=True)
c.inheritAllInterfaces("rfullsplit")
c.addConstraint(("rfullsplit", "toplength"), ("lServoMount.depth", "lServoMount.width", "stack.length"), "(x[0]*2+x[1]*2+10*2+x[2],)")
c.addConstraint(("rfullsplit", "botlength"), ("lServoMount.depth", "lServoMount.width", "stack.length"), "(x[2], x[0]*2+x[1]*2+10*2)")

c.addConnection(("rfullsplit", "topedge0"), ("servosandstack", "rservostacksplit"))
c.addConnection(("batterymount", "leftArmInterface"), ("rfullsplit", "botedge0"), tabWidth=10)

c.inheritInterface("lservostackbatterysplit", ("lfullsplit", "botedge0")) #everything besides the battery + stack section of the split
c.inheritInterface("rservostackbatterysplit", ("rfullsplit", "botedge1"))

c.toLibrary("ServoStackBatteryMount")
